<template>
  <div>
      <el-breadcrumb separator-class="el-icon-arrow-right">
        <el-breadcrumb-item :to="{ path: '/home' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>商品管理</el-breadcrumb-item>
        <el-breadcrumb-item>分类参数</el-breadcrumb-item>
      </el-breadcrumb>

      <el-card>
            <el-alert
                title="注意:只允许分类为三级相关参数"
                type="warning"
                show-icon
                :closable="false">
            </el-alert>

            <el-row class="cat_opt">
                <el-col>
                    <span>选择商品分类:</span>
                    <!-- 级联选择框 -->
                    <!-- options是数据源 -->
                    <el-cascader
                    v-model="selectedCateKeys"
                    :options="cateList"
                    :props="cateProps"
                    expandTrigger= "hover" 
                    @change="handleChange">
                    </el-cascader>
                </el-col>
            </el-row>
            
            
            <el-tabs v-model="activeName" @tab-click="handleTabClick">
                <el-tab-pane label="动态参数" name="many">
                    <el-button type="primary" size="mini" :disabled="isBtnDisabled" @click="dialogVisible = true">添加参数</el-button>
                    <el-table :data="manyTableDate" border stripe="">
                        <el-table-column type="expand">
                            <template slot-scope="scope">
                                <el-tag v-for="(item, i) in scope.row.attr_vals" :key="i" class="elTag" closable>
                                    {{item}}
                                </el-tag>
                                <el-input
                                class="input-new-tag"
                                v-if="inputVisible"
                                v-model="inputValue"
                                ref="saveTagInput"
                                size="small"
                                @keyup.enter.native="handleInputConfirm(scope.row)"
                                @blur="handleInputConfirm(scope.row)"
                                >
                                </el-input>
                                <el-button 
                                v-else class="button-new-tag" 
                                size="small" 
                                @click="showInput"
                                >
                                + New Tag
                                </el-button>
                            </template>
                        </el-table-column>
                        <el-table-column type="index"></el-table-column>
                        <el-table-column label="参数名称" prop="attr_name"></el-table-column>
                        <el-table-column label="操作">
                            <template slot-scope="scope">
                                <el-button 
                                    type="primary" 
                                    icon="el-icon-edit" 
                                    size="mini" 
                                    @click="showDialoog(scope.row.attr_id)"
                                    >
                                    编辑
                                    </el-button>
                                <el-button 
                                    type="danger" 
                                    icon="el-icon-delete" 
                                    size="mini" 
                                    @click="delFrom(scope.row.attr_id)"
                                    >
                                删除
                                </el-button>
                            </template>
                        </el-table-column>
                    </el-table>
                </el-tab-pane>
                <el-tab-pane label="静态属性" name="only">
                    <el-button type="primary" size="mini" :disabled="isBtnDisabled" @click="dialogVisible = true">添加属性</el-button>
                    <el-table :data="manyTableDate" border stripe="">
                        <el-table-column type="expand"></el-table-column>
                        <el-table-column type="index"></el-table-column>
                        <el-table-column label="参数名称" prop="attr_name"></el-table-column>
                        <el-table-column label="操作">
                            <template slot-scope="scope">
                                <el-button 
                                    type="primary" 
                                    icon="el-icon-edit" 
                                    size="mini" 
                                    @click="showDialoog(scope.row.attr_id)"
                                    >
                                    编辑
                                </el-button>
                                <el-button 
                                    type="danger" 
                                    icon="el-icon-delete" 
                                    size="mini" 
                                    @click="delFrom(scope.row.attr_id)"
                                    >
                                    删除
                                </el-button>
                            </template>
                        </el-table-column>
                    </el-table>
                </el-tab-pane>
            </el-tabs>
                
      </el-card>

      <el-dialog
        :title=" '添加' +title "
        :visible.sync="dialogVisible"
        width="50%"
        @close="addDialogClosed">

        <el-form :model="addFrom" :rules="addFromRules" ref="addFromRef" label-width="100px">
            <el-form-item :label="title" prop="attr_name">
                <el-input v-model="addFrom.attr_name"></el-input>
            </el-form-item>
        </el-form>

        <span slot="footer" class="dialog-footer">
            <el-button @click="dialogVisible = false">取 消</el-button>
            <el-button type="primary" @click="addParams">确 定</el-button>
        </span>
      </el-dialog>

    <!-- 修改按钮 -->
      <el-dialog
        :title=" '修改' + title "
        :visible.sync="editDialogVisible"
        width="50%"
        @close="editDialogClosed">

        <el-form :model="editFrom" :rules="editFromRules" ref="editFromRef" label-width="100px">
            <el-form-item :label="title" prop="attr_name">
                <el-input v-model="editFrom.attr_name"></el-input>
            </el-form-item>
        </el-form>

        <span slot="footer" class="dialog-footer">
            <el-button @click="editDialogVisible = false">取 消</el-button>
            <el-button type="primary" @click="editParams">确 定</el-button>
        </span>
      </el-dialog>
  </div>
</template>

<script>
export default {
    data(){
        return{
            inputVisible: false,
            inputValue: '',
            cateList: [],
            // 级联选择框的配置对象
            cateProps: {
                value: 'cat_id',
                label: 'cat_name',
                children: 'children'

            },
            // 级联选择框双向绑定到的数组
            selectedCateKeys: [],
            // 被激活标签的名称
            activeName: 'many',
            manyTableDate: [],
            onlyTableDate: [],
            dialogVisible: false,
            editDialogVisible: false,
            // 添加表单
            addFrom:{
                attr_name: ''
            },
            addFromRules:{
                attr_name:[
                    { required: true, message: '请输入参数名称', trigger: 'change' }
                ]
            },
            editFrom: {
                attr_name: ''
            },
            editFromRules:{
                attr_name:[
                    { required: true, message: '请输入参数名称', trigger: 'change' }
                ]
            }
        }
    },
    created(){
        this.getCateList()
    },
    computed:{
        // 如果按钮需要禁用返回true 否则返回false
        isBtnDisabled(){
            if(this.selectedCateKeys.length !== 3) {
                return true
            } 
            return false
        },
        // 当前选中的三级ID
        cateId(){
            if(this.selectedCateKeys.length === 3){
                return this.selectedCateKeys[2]
            }
            return null
        },
        // 动态改变标题
        title(){
            if(this.activeName === 'many') return '动态参数'
            
            return '静态属性'
        }
        
    },
    methods:{
        async getCateList(){
            const { data:res } = await this.$http.get("categories")
            // console.log(res);
            if(res.meta.status !== 200) return this.$message.error("商品获取失败")
            this.cateList = res.data
        },
        // 级联选择框选择项变化，触发此函数
        handleChange(){
            // console.log(this.selectedCateKeys);
            this.getParamsData()
        },
        async getParamsData(){
            if(this.selectedCateKeys.length !== 3) {
                this.selectedCateKeys = []
                this.manyTableDate = []
                this.onlyTableDate = []
                return
            } 
             const { data:res} = await this.$http.get(`categories/${this.cateId}/attributes`, { params: {sel: this.activeName}})
             if(res.meta.status !== 200) return this.$message.error("参数列表获取失败")
            //  console.log(res.data)
             res.data.forEach( item => {
                 item.attr_vals = item.attr_vals ? item.attr_vals.split(' '): []
             })
            //  console.log('???????????????', res.data)
            if(this.activeName === 'many'){
                this.manyTableDate = res.data
            }
            this.onlyTableDate = res.data
        },
        // tabs页签点击处理函数
        handleTabClick(){
            // console.log(this.activeName);
            this.getParamsData()
        },
        addDialogClosed(){
            this.$refs.addFromRef.resetFields()
            
        },
        addParams(){
            this.$refs.addFromRef.validate(async valid => {
                if(!valid) return
                const {data:res} = await this.$http.post(`categories/${this.cateId}/attributes`, 
                {attr_name: this.addFrom.attr_name,
                attr_sel: this.activeName}  )
                // console.log(res);
                if(res.meta.status !== 201) return this.$message.error("添加参数失败")
                return this.$message.success("添加成功")
            })
            this.dialogVisible = false
            this.getParamsData()
        },
        async showDialoog(attr_id) {
            this.editDialogVisible = true
            const {data:res} = await this.$http.get(`categories/${this.cateId}/attributes/${attr_id}`, 
            { params: {attr_sel: this.activeName}})
            // console.log('~~~~~~~~~', res)
             if(res.meta.status !== 200) return this.$message.error("获取参数信息失败")
             return this.editFrom = res.data
            
            
        },
        editDialogClosed() {
            this.$refs.editFromRef.resetFields()
        },
        editParams() {
            this.$refs.editFromRef.validate(async val => {
                if(!val) return
                const {data:res} = await this.$http.put(`categories/${this.cateId}/attributes/${this.editFrom.attr_id}`, 
                    {attr_name: this.editFrom.attr_name,
                    attr_sel: this.editFrom.attr_sel}
                )
                // console.log('%%%%%%%%%%%%%%', res)
                if(res.meta.status !== 200) return this.$message.error("修改失败")
                return this.$message.success('修改成功')
            })
            this.getParamsData()
            this.editDialogVisible = false
        },
        async delFrom(attr_id) {
            const confirmResult = await this.$confirm('此操作将永久删除该参数, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
            }).catch( err => err)

            if( confirmResult !== 'confirm') {
                return this.$message.info('已取消删除!')
            }
            const { data: res} = await this.$http.delete(`categories/${this.cateId}/attributes/${attr_id}`)
            // console.log('###########', res)
            if(res.meta.status !== 200) return this.$message.error("删除失败")
            return this.$message.success('删除成功')
            this.getParamsData()
        },
        handleInputConfirm() {
            // this.inputVisible = false
            // this.attr_vals.push(this.inputValue)
            // this.inputValue = ''
            // this.inputVisible = false
        },
        showInput() {
            this.inputVisible = true
            // $nextTick方法作用，当页面上元素被重新渲染才指定回调函数中的代码
            this.$nextTick(_ => {
                this.$refs.saveTagInput.$refs.input.focus();
            })
        }
    }
}
</script>

<style scoped>
.cat_opt {
    margin: 15px 0;
}
.elTag {
    margin: 5px 10px;
}
.input-new-tag {
    width: 100px;
}
</style>